module (..., package.seeall)

mvc = {}
mvc.on_load = function(self, parent)
	self.model.set_processname(string.match(self.conf.prefix, "[^/]+"))
end

default_action = "status"

status = function(self)
	return self.model.getstatus()
end

startstop = function(self)
	return self.handle_form(self, self.model.get_startstop, self.model.startstop_service, self.clientdata)
end

expert = function(self)
	return self.handle_form(self, self.model.get_filecontent, self.model.update_filecontent, self.clientdata, "Save", "Edit Config File", "Config File Saved")
end

viewconfig = function(self)
	return self.model.get_config()
end

statusinfo = function (self)
	return self.model.getclientinfo()
end

logfile = function (self)
	return self.model.get_logfile()
end

function listcerts(self)
	return self.model.list_certs()
end

function deletecert(self)
	return self.handle_form(self, self.model.get_delete_cert, self.model.delete_cert, self.clientdata, "Delete", "Delete Certificate", "Certificate Deleted")
end

function uploadcert (self)
	return self.handle_form(self, self.model.new_upload_cert, self.model.upload_cert, self.clientdata, "Upload", "Upload Certificate", "Certificate Uploaded")
end

function viewcert(self)
	return self.model.view_cert(self.clientdata.cert)
end

function generatedhparams(self)
	return self.handle_form(self, self.model.get_generate_dh_params, self.model.generate_dh_params, self.clientdata, "Generate", "Generate Diffie Hellman parameters", "Diffie Hellman parameters generated")
end
